stock ResetScramble()
{
	for (new i = 1; i <= MaxClients; i++)
	{
		if (IsClientHuman(i)) bAssigned[i] = false;
	}
}

stock FindValidPlayers()
{
	new count = 0;
	for (new i = 1; i <= MaxClients; i++)
	{
		if (!IsClientHuman(i)) continue;
		if (!IsReserve(i)) bAway[i] = false;
		if (bAway[i])
		{
			bAssigned[i] = true;
			if (GetClientTeam(i) != TEAM_SPECTATOR) JoinTargetTeam(i, TEAM_SPECTATOR);
		}
		if (bAssigned[i] || bAway[i]) continue;
		count++;
	}
	return count;
}

stock PlayersRemaining()
{
	new count = 0;
	for (new i = 1; i <= MaxClients; i++)
	{
		if (!IsClientHuman(i)) continue;
		if (bAssigned[i] || bAway[i]) continue;
		count++;
		bAssigned[i] = false;
	}
	return count;
}

stock FindPlayersRank(RankPosition)
{
	new count = 0;
	for (new i = 1; i <= MaxClients; i++)
	{
		if (!IsClientHuman(i) || bAssigned[i] || bAway[i] || Rank[i] != RankPosition) continue;
		count++;
	}
	return count;
}

public Scramble(bool:SmartMode)
{
	if (GetConVarInt(g_Module_Teams_Scramble) == 0) return;
	ResetScramble();
	new infected = 0;
	new survivor = 0;
	//new validplayers = FindValidPlayers();
	if (GetConVarInt(g_Debug) == 1) LogToFile(LOGFILE, "[Scramble] Valid players: %d , required to scramble: %d", FindValidPlayers(), GetConVarInt(g_Module_Teams_ScrambleRequirement));
	if (FindValidPlayers() < GetConVarInt(g_Module_Teams_ScrambleRequirement)) return;

	IsScramble = true;

	PrintToChatAll("%t", "Team Scramble", white, blue);
	LastScramble = 0;			// So scramble does not occur every map.

	// Reset both teams scores when a scramble occurs.
	ResetCampaignScores();

	if (!SmartMode)
	{
		while (FindValidPlayers() > 0)
		{
			new i = GetRandomInt(1, MaxClients);
			new random = GetRandomInt(1, 2);
			if (IsClientHuman(i) && !bAssigned[i])
			{
				if (infected < survivor || (infected == survivor && random == 1))
				{
					JoinTargetTeam(i, TEAM_INFECTED);
					infected++;
				}
				else if (survivor < infected || (infected == survivor && random == 2))
				{
					JoinTargetTeam(i, TEAM_SURVIVORS);
					survivor++;
				}
				bAssigned[i] = true;
			}
		}
	}
	else
	{
		/*
		//		Don't need to get client ranks anymore, as they're loaded when each player data loads
		//		and only once per round.
																																			*/
		for (new i = 1; i <= MaxClients; i++)
		{
			if (!IsClientHuman(i)) continue;
			GetClientRank(i);
		}
		CreateTimer(1.0, Timer_SmartScramble, _, TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
	}
}

public Action:Timer_KickSurvivorBots_Scramble(Handle:timer)
{
	KickSurvivorBots();
	return Plugin_Stop;
}

public Action:Timer_SmartScramble(Handle:timer)
{
	static count		=	0;

	count++;
	PrintHintTextToAll("%t", "Smart Scramble Countdown", GetConVarInt(g_SmartScrambleCountdown) - count);
	if (count >= GetConVarInt(g_SmartScrambleCountdown))
	{
		new RankLowPosition			= 0;
		new RankHighPosition		= RankMaximum;
		if (GetConVarInt(g_Debug) == 1) LogToFile(LOGFILE, "[Scramble] Maximum Server Rank: %d", RankMaximum);

		new RankPosition			= GetRandomInt(1, 2);
		new AssignCount			= GetRandomInt(2, 3);

		if (RankPosition == 1)		RankPosition = RankLowPosition;
		else						RankPosition = RankHighPosition;

		while (FindValidPlayers() > 0)
		{
			while (FindValidPlayers() > 0 && FindPlayersRank(RankPosition) > 0)
			{
				new client = GetRandomInt(1, MaxClients);

				if (IsClientHuman(client) && !bAssigned[client] && !bAway[client] && Rank[client] == RankPosition)
				{
					bAssigned[client] = true;
					if (AssignCount == TEAM_SURVIVORS)
					{
						if (GetConVarInt(g_Debug) == 1) LogToFile(LOGFILE, "[Scramble] Assigning %N (rank: %d) to Survivor Team.", client, Rank[client]);
						JoinTargetTeam(client, TEAM_SURVIVORS);
						AssignCount = TEAM_INFECTED;
					}
					else
					{
						if (GetConVarInt(g_Debug) == 1) LogToFile(LOGFILE, "[Scramble] Assigning %N (rank: %d) to Infected Team.", client, Rank[client]);
						JoinTargetTeam(client, TEAM_INFECTED);
						AssignCount = TEAM_SURVIVORS;
					}
				}
			}
			if (RankPosition == RankLowPosition)
			{
				RankPosition = RankHighPosition;
				RankLowPosition++;
			}
			else if (RankPosition == RankHighPosition)
			{
				RankPosition = RankLowPosition;
				RankHighPosition--;
			}
		}
		if (GetConVarInt(g_Debug) == 1) LogToFile(LOGFILE, "[Scramble] Scramble is finished.");
		IsScramble = false;
		count = 0;
		return Plugin_Stop;
	}
	return Plugin_Continue;
}